#coding:utf-8
#import datetime
from django.db import models
from device.models import Device

#未注册数据表
class Unregister(models.Model):
	product_id = models.CharField(max_length=20,verbose_name='product_id',unique=True)    #.OneToOneField(Device, on_delete=models.DO_NOTHING, to_field="product_id", unique=True)
	imei = models.CharField(max_length=16, verbose_name='imei', blank=True, null=True)
	pressure = models.FloatField(verbose_name='压力', blank=True, null=True)
	pressure_stand = models.CharField(max_length=32, verbose_name='压力标定值', blank=True, null=True)
	pressure_stand_full = models.FloatField(verbose_name='标定满度压力值', blank=True, null=True)
	pressure_stand_middle = models.FloatField(verbose_name='中间压力标定值', blank=True, null=True)
	pressure_alarm = models.CharField(max_length=32, verbose_name='压力低报警压力高报警', blank=True, null=True)

	temperature = models.FloatField( verbose_name='温度', blank=True, null=True)
	temperature_stand = models.CharField(max_length=32, verbose_name='温度标定值', blank=True, null=True)
	temperature_sensor = models.PositiveIntegerField(verbose_name='温度传感器类型', blank=True, null=True)

	sampling_period = models.PositiveIntegerField(verbose_name='采样周期', blank=True, null=True)
	userips = models.CharField(max_length=32, verbose_name='ip:端口号', blank=True, null=True)
	myips = models.CharField(max_length=32, verbose_name='备用ip:端口号', blank=True, null=True)
	dataup_interval = models.PositiveIntegerField(verbose_name='数据发送周期(上报时间间隔)', blank=True, null=True)
	comm_firmware_version = models.CharField(max_length=24, verbose_name='通讯模块固件版本号', blank=True, null=True)
	ccid = models.CharField(max_length=20, verbose_name='ccid', blank=True, null=True)
	signal = models.PositiveIntegerField(verbose_name='信号强度', blank=True, null=True)
	work_mode = models.PositiveIntegerField(verbose_name='工作模式', blank=True, null=True)
	gps_switch = models.PositiveIntegerField(verbose_name='gps开关', blank=True, null=True)
	motion_alarm = models.PositiveIntegerField(verbose_name='运动检测阙值', blank=True, null=True)  #
	motion_switch = models.PositiveIntegerField(verbose_name='运动检测开关', blank=True, null=True)
	report_punctually = models.PositiveIntegerField(verbose_name='数据发送时刻', blank=True, null=True)
	baterry_voltage = models.PositiveIntegerField(verbose_name='电池电压', blank=True, null=True)
	media = models.PositiveIntegerField(verbose_name='介质', blank=True, null=True)
	vessel_type = models.PositiveIntegerField(verbose_name='容器类型', blank=True, null=True)
	nominal_volume = models.PositiveIntegerField(verbose_name='容器公称容积', blank=True, null=True)  # 单位 ：L  立方
	vessel_diameter = models.PositiveIntegerField(verbose_name='容器直径', blank=True, null=True)  # 单位 mm
	acceleration_xyz = models.CharField(max_length=32, verbose_name='加速度XYZ', blank=True, null=True)  # 加速度传感器
	gas_volume =  models.FloatField(verbose_name='气体体积(标方)', blank=True, null=True)

	status = models.CharField(max_length=8, verbose_name='状态', blank=True, null=True)
	up_numbers = models.PositiveIntegerField(verbose_name='上报次数', blank=True, null=True)
	is_handle = models.NullBooleanField(verbose_name='报警是否处理')
	update_time = models.DateTimeField(verbose_name='实时时间/数据发送时间', blank=True, null=True)
	version = models.CharField(max_length=32, verbose_name='版本号', blank=True, null=True)
	reg_tables = models.CharField(max_length=16, verbose_name='注册类型到表名', blank=True, null=True)  # data_表名
	create_time = models.DateTimeField(auto_now=True, blank=True, null=True)

	class Meta:
		db_table = 'data_unregister'


'''
	长管拖车
	温度传感器类型 温度传感器标定值 压力 压力标定值 标定满度压力值 压力报警值 采样周期 中间压力标定值
	用户ip 自用ip 数据发送周期 imei 通讯模块固件版本号 ccid 信号强度 工作模式 gps开关 运动监测开关
	运动监测阙值  数据发送时刻 电池电压 介质类型 容器类型 容器容积 容器直径 介质温度
'''
class trailer(models.Model):
	product = models.OneToOneField(Device, on_delete=models.DO_NOTHING, to_field="product_id", unique=True)
	imei = models.CharField(max_length=16, verbose_name='imei', blank=True, null=True)

	pressure = models.FloatField(verbose_name='压力', blank=True, null=True)
	pressure_stand = models.CharField(max_length=32, verbose_name='压力标定值', blank=True, null=True)
	pressure_stand_full = models.FloatField(verbose_name='标定满度压力值', blank=True, null=True)
	pressure_stand_middle = models.FloatField(verbose_name='中间压力标定值', blank=True, null=True)
	pressure_alarm = models.CharField(max_length=32, verbose_name='压力低报警压力高报警', blank=True, null=True)

	temperature = models.FloatField(verbose_name='温度', blank=True, null=True)
	temperature_stand = models.CharField(max_length=32, verbose_name='温度标定值', blank=True, null=True)
	temperature_sensor = models.PositiveIntegerField(verbose_name='温度传感器类型', blank=True, null=True)
	
	gas_volume = models.FloatField(verbose_name='气体体积(标方)', blank=True, null=True)
	sampling_period = models.PositiveIntegerField(verbose_name='采样周期', blank=True, null=True)
	userips = models.CharField(max_length=32, verbose_name='ip:端口号', blank=True, null=True)
	myips = models.CharField(max_length=32, verbose_name='备用ip:端口号', blank=True, null=True)
	dataup_interval = models.PositiveIntegerField(verbose_name='数据发送周期(上报时间间隔)', blank=True, null=True)
	comm_firmware_version = models.CharField(max_length=24, verbose_name='通讯模块固件版本号', blank=True, null=True)
	ccid = models.CharField(max_length=20, verbose_name='ccid', blank=True, null=True)
	signal = models.PositiveIntegerField(verbose_name='信号强度', blank=True, null=True)
	work_mode = models.PositiveIntegerField(verbose_name='工作模式', blank=True, null=True)
	gps_switch = models.PositiveIntegerField(verbose_name='gps开关', blank=True, null=True)
	motion_alarm = models.PositiveIntegerField(verbose_name='运动检测阙值', blank=True, null=True)  #
	motion_switch = models.PositiveIntegerField(verbose_name='运动检测开关', blank=True, null=True)
	report_punctually = models.PositiveIntegerField(verbose_name='数据发送时刻', blank=True, null=True)
	baterry_voltage = models.PositiveIntegerField(verbose_name='电池电压', blank=True, null=True)
	media = models.PositiveIntegerField(verbose_name='介质', blank=True, null=True)
	vessel_type = models.PositiveIntegerField(verbose_name='容器类型', blank=True, null=True)
	nominal_volume = models.PositiveIntegerField(verbose_name='容器公称容积', blank=True, null=True)  # 单位 ：L  立方
	vessel_diameter = models.PositiveIntegerField(verbose_name='容器直径', blank=True, null=True)  # 单位 mm
	acceleration_xyz = models.CharField(max_length=32, verbose_name='加速度XYZ', blank=True, null=True)  # 加速度传感器

	status = models.CharField(max_length=8, verbose_name='状态', blank=True, null=True)
	up_numbers = models.PositiveIntegerField(verbose_name='上报次数', blank=True, null=True)
	is_handle = models.NullBooleanField(verbose_name='报警是否处理')
	update_time = models.DateTimeField(verbose_name='实时时间/数据发送时间', blank=True, null=True)
	
	version = models.CharField(max_length=32, verbose_name='版本号', blank=True, null=True)
	create_time = models.DateTimeField(auto_now=True, blank=True, null=True)

	class Meta:
		db_table = 'data_trailer'


#地图位置表
class map(models.Model):
	product_id = models.CharField(max_length=16, verbose_name='产品ID',unique=True)
	mnc = models.PositiveIntegerField(blank=True, null=True)
	mcc = models.PositiveIntegerField(blank=True, null=True)
	lac = models.PositiveIntegerField(blank=True, null=True)
	cid = models.PositiveIntegerField(blank=True, null=True)
	lng = models.CharField(max_length=32,blank=True, null=True)
	lat = models.CharField(max_length=32,blank=True, null=True)
	create_time = models.DateTimeField(verbose_name='创建时间')
	update_time = models.DateTimeField(verbose_name='更新时间',blank=True, null=True)
	class Meta:
		db_table = 'map_list'

#地图位置历史表
class maplog(models.Model):
	product_id = models.CharField(max_length=16, verbose_name='产品ID')
	mnc = models.PositiveIntegerField(blank=True, null=True)
	mcc = models.PositiveIntegerField(blank=True, null=True)
	lac = models.PositiveIntegerField(blank=True, null=True)
	cid = models.PositiveIntegerField(blank=True, null=True)
	lng = models.CharField(max_length=32,blank=True, null=True)
	lat = models.CharField(max_length=32,blank=True, null=True)
	update_time = models.DateTimeField(verbose_name='更新时间')
	class Meta:
		unique_together = ("product_id", "update_time")
		db_table = 'map_history'


'''
	-----------------------------------------------------------------------------------------------------------------------
	-----------------------------------------	  历史记录分界线    	---------------------------------------------------
	-----------------------------------------------------------------------------------------------------------------------
'''
# 介质温度
class temperature(models.Model):
	product_id = models.CharField(max_length=16, verbose_name='产品ID')
	val = models.FloatField(verbose_name='温度')
	time = models.PositiveIntegerField()
	class Meta:
		unique_together = ("product_id", "time")
		db_table = 'his_temperature'

# 压力
class pressure(models.Model):
	product_id = models.CharField(max_length=16, verbose_name='产品ID')
	val = models.FloatField(verbose_name='压力')
	time = models.PositiveIntegerField()
	class Meta:
		unique_together = ("product_id", "time")
		db_table = 'his_pressure'


# 电池电压
class baterryVoltage(models.Model):
	product_id = models.CharField(max_length=16, verbose_name='产品ID')
	val = models.PositiveIntegerField(verbose_name='电池电压', blank=True, null=True)
	time = models.PositiveIntegerField()
	class Meta:
		unique_together = ("product_id", "time")
		db_table = 'his_baterry_voltage'


# 信号强度
class signal(models.Model):
	product_id = models.CharField(max_length=16, verbose_name='产品ID')
	val = models.CharField(max_length=32)
	time = models.PositiveIntegerField()
	class Meta:
		unique_together = ("product_id", "time")
		db_table = 'his_signal'

#加速度 X,Y ,Z
class accelerationXYZ(models.Model):
	product_id = models.CharField(max_length=16, verbose_name='产品ID')
	v_x = models.IntegerField()
	v_y = models.IntegerField()
	v_z = models.IntegerField()
	time = models.PositiveIntegerField()
	class Meta:
		unique_together = ("product_id", "time")
		db_table = 'his_acceleration_xyz'
#标方: gas_volume
class gasVolume(models.Model):
	product_id = models.CharField(max_length=16, verbose_name='产品ID')
	val = models.FloatField(verbose_name='标方')
	time = models.PositiveIntegerField()
	class Meta:
		unique_together = ("product_id", "time")
		db_table = 'his_gas_volume'
		